/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.blocks.misc;

import net.minecraft.class_1297;
import net.minecraft.class_1309;
import net.minecraft.class_1657;
import net.minecraft.class_1665;
import net.minecraft.class_1927;
import net.minecraft.class_1937;
import net.minecraft.class_2246;
import net.minecraft.class_2248;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_2689;
import net.minecraft.class_2746;
import net.minecraft.class_3417;
import net.minecraft.class_3419;
import net.minecraft.class_3614;
import reborncore.common.BaseBlock;
import techreborn.config.TechRebornConfig;
import techreborn.entities.EntityNukePrimed;

/**
 * Created by Mark on 13/03/2016.
 */
public class BlockNuke extends BaseBlock {
	public static class_2746 OVERLAY = class_2746.method_11825("overlay");

	public BlockNuke() {
		super(class_2248.class_2251.method_9637(class_3614.field_15955));
		this.method_9590(this.method_9595().method_11664().method_11657(OVERLAY, false));
	}

	public void ignite(class_1937 worldIn, class_2338 pos, class_2680 state, class_1309 igniter) {
		if (!worldIn.field_9236) {
			EntityNukePrimed entitynukeprimed = new EntityNukePrimed(worldIn, (double) ((float) pos.method_10263() + 0.5F),
					(double) pos.method_10264(), (double) ((float) pos.method_10260() + 0.5F), igniter);
			worldIn.method_8649(entitynukeprimed);
			worldIn.method_8465((class_1657) null, entitynukeprimed.method_23317(), entitynukeprimed.method_23318(), entitynukeprimed.method_23321(),
					class_3417.field_15079, class_3419.field_15245, 1.0F, 1.0F);
		}
	}

	@Override
	public void method_9586(class_1937 worldIn, class_2338 pos, class_1927 explosionIn) {
		if (!worldIn.field_9236) {
			EntityNukePrimed entitynukeprimed = new EntityNukePrimed(worldIn, (double) ((float) pos.method_10263() + 0.5F),
					(double) pos.method_10264(), (double) ((float) pos.method_10260() + 0.5F), explosionIn.method_8347());
			entitynukeprimed.method_6967(worldIn.field_9229.nextInt(TechRebornConfig.nukeFuseTime / 4) + TechRebornConfig.nukeFuseTime / 8);
			worldIn.method_8649(entitynukeprimed);
		}
	}

	@Override
	public void method_9548(class_2680 state, class_1937 worldIn, class_2338 pos, class_1297 entityIn) {
		if (!worldIn.field_9236 && entityIn instanceof class_1665) {
			class_1665 entityarrow = (class_1665) entityIn;
			class_1309 shooter = null;
			if (entityarrow.method_7452() instanceof class_1309) {
				shooter = (class_1309) entityarrow.method_7452();
			}
			if (entityarrow.method_5809()) {
				ignite(worldIn, pos, state, shooter);
				worldIn.method_8501(pos, class_2246.field_10124.method_9564());
			}
		}
	}

	@Override
	public void method_9615(class_2680 state, class_1937 worldIn, class_2338 pos, class_2680 oldState, boolean b) {
		super.method_9615(state, worldIn, pos, oldState, b);
		if (worldIn.method_8479(pos)) {
			ignite(worldIn, pos, state, null);
			worldIn.method_8501(pos, class_2246.field_10124.method_9564());
		}
	}

	@Override
	public void method_9612(class_2680 state, class_1937 worldIn, class_2338 pos, class_2248 blockIn, class_2338 p_189540_5_, boolean bo) {
		if (worldIn.method_8479(pos)) {
			ignite(worldIn, pos, state, null);
			worldIn.method_8501(pos, class_2246.field_10124.method_9564());
		}
	}
	
	@Override
	protected void method_9515(class_2689.class_2690<class_2248, class_2680> builder) {
		builder.method_11667(OVERLAY);
	}
}
