/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.init;

import java.util.Locale;
import java.util.function.Supplier;
import net.minecraft.class_1304;
import net.minecraft.class_1741;
import net.minecraft.class_1856;
import net.minecraft.class_3414;
import net.minecraft.class_3417;
import net.minecraft.class_3528;


public enum TRArmorMaterial implements class_1741 {

	BRONZE(17, new int[] { 3, 6, 5,	2 }, 8, class_3417.field_14862, 0.0F, () -> {
		return class_1856.method_8091(TRContent.Ingots.BRONZE.method_8389());
	}), 
	RUBY(16, new int[] { 2, 7, 5, 2 }, 10, class_3417.field_15103, 0.0F, () -> {
		return class_1856.method_8091(TRContent.Gems.RUBY.method_8389());
	}), 
	SAPPHIRE(19, new int[] { 4, 4, 4, 4 }, 8, class_3417.field_15103, 0.0F, () -> {
				return class_1856.method_8091(TRContent.Gems.SAPPHIRE.method_8389());
			}), 
	PERIDOT(17, new int[] { 3, 8, 3, 2 }, 16, class_3417.field_15103, 0.0F, () -> {
		return class_1856.method_8091(TRContent.Gems.PERIDOT.method_8389());
	}), 
	CLOAKING(5, new int[] { 1, 2, 3, 1 }, 0, class_3417.field_14761, 0.0F, () -> class_1856.field_9017),
	LITHIUMBATPACK(25, new int[]{2, 5, 6, 2}, 10, class_3417.field_14684, 0.0F, () -> class_1856.field_9017),
	LAPOTRONPACK(33, new int[]{3, 6, 8, 3}, 10, class_3417.field_15103, 2.0F, () -> class_1856.field_9017);
	

	private static final int[] MAX_DAMAGE_ARRAY = new int[]{13, 15, 16, 11};
	private final int maxDamageFactor;
	private final int[] damageReductionAmountArray;
	private final int enchantability;
	private final class_3414 soundEvent;
	private final float toughness;
	private final class_3528<class_1856> repairMaterial;

	TRArmorMaterial(int maxDamageFactor, int[] damageReductionAmountArray, int enchantability,
                    class_3414 soundEvent, float toughness, Supplier<class_1856> repairMaterialIn) {
		this.maxDamageFactor = maxDamageFactor;
		this.damageReductionAmountArray = damageReductionAmountArray;
		this.enchantability = enchantability;
		this.soundEvent = soundEvent;
		this.toughness = toughness;
		this.repairMaterial = new class_3528<>(repairMaterialIn);
	}

	@Override
	public int method_7696(class_1304 slotIn) {
		return MAX_DAMAGE_ARRAY[slotIn.method_5927()] * maxDamageFactor;
	}

	@Override
	public int method_7697(class_1304 slotIn) {
		return damageReductionAmountArray[slotIn.method_5927()];
	}

	@Override
	public int method_7699() {
		return enchantability;
	}

	@Override
	public class_3414 method_7698() {
		return soundEvent;
	}

	@Override
	public class_1856 method_7695() {
		return repairMaterial.method_15332();
	}

	@Override
	public String method_7694() {
		return this.toString().toLowerCase(Locale.ROOT);
	}

	@Override
	public float method_7700() {
		return toughness;
	}
}
