/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2018 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.world;

import com.mojang.datafixers.Dynamic;
import techreborn.init.TRContent;

import java.util.Random;
import java.util.Set;
import java.util.function.Function;
import java.util.function.Predicate;
import net.minecraft.class_2338;
import net.minecraft.class_2680;
import net.minecraft.class_3207;
import net.minecraft.class_3341;
import net.minecraft.class_3747;
import net.minecraft.class_4640;

/**
 * @author drcrazy
 *
 */
public class RubberTreeFeature extends class_3207 {

	public RubberTreeFeature(Function<Dynamic<?>, ? extends class_4640> configFactory) {
		super(configFactory);
	}

	@Override
	public boolean method_23402(class_3747 world, Random random, class_2338 blockPos, Set<class_2338> set, Set<class_2338> set2, class_3341 blockBox, class_4640 branchedTreeFeatureConfig) {
		if(super.method_23402(world, random, blockPos, set, set2, blockBox, branchedTreeFeatureConfig)) {
			spawnSpike(world, blockPos);
			return true;
		}
		return false;
	}

	private void spawnSpike(class_3747 world, class_2338 pos) {
		final int startScan = pos.method_10264();
		class_2338 topPos = null;

		//Limit the scan to 15 blocks
		while(topPos == null && pos.method_10264() - startScan < 15) {
			pos = pos.method_10084();
			if(world.method_16358(pos, class_2680::method_11588)) {
				topPos = pos;
			}
		}

		if(topPos == null) return;

		for (int i = 0; i < 3; i++) {
			method_13153(world, pos.method_10086(i), TRContent.RUBBER_LEAVES.method_9564());
		}
	}
}
